;*******************(C) COPYRIGHT 2020 Masses-Chip ******************************
;* File Name          : M8P634_Touch_M1_Lib_CFG.ASM
;* Author             : MASSES CHIP
;* Version            : V2.06
;* Date               : 2020/03/30
;********************************************************************************

; 本文件用户不可自行修改

;================================================================================
#include     m8P634.inc   
#include     M8R_P_MACRO.inc
#include     M8P634_Touch_M1_Lib.inc 
#include     M8P634_Touch_M1_Lib_CFG.INC  

;================================================================================ 
       
 LIST    p=m8P634

;================================================================================  

 
;================================================================================  
 CODE 
 
;================================================================================        
#if TKLib_TouchLowerPower 
 ;FUNC 
 GLOBAL _RCOUT_OUTPUT_EN   
 GLOBAL _RCOUT_OUTPUT_DIS 
 GLOBAL _WDT_WakeUp_Handle  
#endif 

;================================================================================        
 GLOBAL _ScanNextChannel 
 GLOBAL _TkSignalHandle_Next 

 extern TKCOM_PIN_OUT
 extern _READ_TK_EN_MASK_DATA 
 
 extern TAB_TOUCH_FN_DATA 
 extern _RChannelEnL    
 extern _RChannelEnH  

 extern _RTkTemp9    
 extern _RTkTemp10 
#define RTkmaskL        _RTkTemp9
#define RTkmaskH        _RTkTemp10

 extern _RTkTemp2 
#define berror_F        _RTkTemp2,4 

 extern _RTkTemp4 
#define _R_CNT          _RTkTemp4

 extern _RTkBuff2 
#define RTk_CH            _RTkBuff2

 GLOBAL _other_lib_fun1
 GLOBAL _other_lib_fun2 

#if  (TKLib_FILTER_LEVEL > 0)
 extern _other_fun1  
 extern _other_fun2 
#endif

 EXTERN     _RTkBitFlag 

;==================================================================== 
#if TKLib_TouchLowerPower
_WDT_WakeUp_Handle:
; Stack:	Level 1
; INPUT:	 
; OUTPUT:	
; OTHER	:
;此程序是在触摸低功耗模式下，需要处理的操作，如有需要可增加操作程序  
;如RTC时钟1S计时程序,LCD时钟刷新显示程序等等
  
  
  
  
; bclr  bLowPowerModeRun ; 可根据需求，判断系统是否需要强制唤醒(清bLowPowerModeRun，强制唤醒系统)
                         
    return 
#endif

;================================================================================   
;以下用户可不查看 
;================================================================================    
#if TKLib_TouchLowerPower 
_RCOUT_OUTPUT_EN:
; Stack:	Level 1
; INPUT:	 
; OUTPUT:	
; OTHER	:

#if TKLPLib_RCOUT_EN	
    bclr    P_RCOUT,N_RCOUT 
    bset    OE_RCOUT,N_RCOUT
#endif 	
    return		  
#endif 
  
;================================================================================  
#if TKLib_TouchLowerPower 
_RCOUT_OUTPUT_DIS:
; Stack:	Level 1
; INPUT:	 
; OUTPUT:	
; OTHER	:
	
#if TKLPLib_RCOUT_EN
    bclr    OE_RCOUT,N_RCOUT  
#endif 
    return		  
#endif 


;==================================================================== 
_ScanNextChannel:
; Stack:	Level 3
; INPUT:	 
; OUTPUT:	
; OTHER	:	

    CALL    TKCOM_PIN_OUT 	

; set tk ch	
    clrr    TK1CHSL
    clrr    TK1CHSH  ;关闭所有连接的通道

#if EnTk16		
    jbts0   _RChannelEnL,0
    goto    scantk16_set
#endif

#if EnTk17	    
    jbts0   _RChannelEnL,1
    goto    scantk17_set
#endif

#if EnTk18	    
    jbts0   _RChannelEnL,2
    goto    scantk18_set
#endif

#if EnTk19	    
    jbts0   _RChannelEnL,3
    goto    scantk19_set
#endif

#if EnTk20	    
    jbts0   _RChannelEnL,4
    goto    scantk20_set
#endif

#if EnTk21	    
    jbts0   _RChannelEnL,5
    goto    scantk21_set
#endif

#if EnTk22	    
    jbts0   _RChannelEnL,6
    goto    scantk22_set
#endif

#if EnTk23	    
    jbts0   _RChannelEnL,7
    goto    scantk23_set
#endif

#if EnTk24	    
    jbts0   _RChannelEnH,0
    goto    scantk24_set
#endif

#if EnTk25	    
    jbts0   _RChannelEnH,1
    goto    scantk25_set
#endif

#if EnTk26	    
    jbts0   _RChannelEnH,2
    goto    scantk26_set
#endif

#if EnTk27	    
    jbts0   _RChannelEnH,3
    goto    scantk27_set
#endif

#if EnTk28	    
    jbts0   _RChannelEnH,4
    goto    scantk28_set
#endif

#if EnTk29	    
    jbts0   _RChannelEnH,5
    goto    scantk29_set
#endif

#if EnTk30	    
    jbts0   _RChannelEnH,6
    goto    scantk30_set
#endif

#if EnTk31	    
    jbts0   _RChannelEnH,7
    goto    scantk31_set
#endif

    bset    bOneScanDone
    CALL    _READ_TK_EN_MASK_DATA  
    goto    ScanNextChannel_end ;error	
    
#if EnTk16		
scantk16_set:
    bclr    _RChannelEnL,0	 
    bset    TK1CHSL,0  		
    goto    ScanNextChannel_end_1			
#endif

#if EnTk17		
scantk17_set:
    bclr    _RChannelEnL,1		 
    bset    TK1CHSL,1  		
    goto    ScanNextChannel_end_1	
#endif

#if EnTk18		 
scantk18_set:
    bclr    _RChannelEnL,2		 
    bset    TK1CHSL,2  		
    goto    ScanNextChannel_end_1
#endif

#if EnTk19	
scantk19_set:
    bclr    _RChannelEnL,3	 
    bset    TK1CHSL,3  		
    goto    ScanNextChannel_end_1
#endif

#if EnTk20			 
scantk20_set:
    bclr    _RChannelEnL,4	 
    bset    TK1CHSL,4  		
    goto    ScanNextChannel_end_1
#endif

#if EnTk21		 
scantk21_set:
    bclr    _RChannelEnL,5	 
    bset    TK1CHSL,5  		
    goto    ScanNextChannel_end_1
#endif

#if EnTk22		 
scantk22_set:
    bclr    _RChannelEnL,6	 
    bset    TK1CHSL,6 		
    goto    ScanNextChannel_end_1
#endif

#if EnTk23		 
scantk23_set:
    bclr    _RChannelEnL,7	 
    bset    TK1CHSL,7  		
    goto    ScanNextChannel_end_1
#endif

#if EnTk24		 
scantk24_set:
    bclr    _RChannelEnH,0		 
    bset    TK1CHSH,0  		
    goto    ScanNextChannel_end_1
#endif

#if EnTk25	 
scantk25_set:
    bclr    _RChannelEnH,1	 
    bset    TK1CHSH,1  		
    goto    ScanNextChannel_end_1
#endif

#if EnTk26		 
scantk26_set:
    bclr    _RChannelEnH,2	 
    bset    TK1CHSH,2  		
    goto    ScanNextChannel_end_1
#endif
	
#if EnTk27		 
scantk27_set:
    bclr    _RChannelEnH,3	 
    bset    TK1CHSH,3  		
    goto    ScanNextChannel_end_1
#endif

#if EnTk28		 
scantk28_set:
    bclr    _RChannelEnH,4	 
    bset    TK1CHSH,4  		
    goto    ScanNextChannel_end_1
#endif
  
#if EnTk29		 
scantk29_set:
    bclr    _RChannelEnH,5	 
    bset    TK1CHSH,5  		
    goto    ScanNextChannel_end_1
#endif

#if EnTk30		 
scantk30_set:
    bclr    _RChannelEnH,6	 
    bset    TK1CHSH,6  		
    goto    ScanNextChannel_end_1
#endif

#if EnTk31		 
scantk31_set:
    bclr    _RChannelEnH,7	 
    bset    TK1CHSH,7  		
    goto    ScanNextChannel_end_1
#endif  
  
ScanNextChannel_end_1:
    incr    RTk_CH,r
	
ScanNextChannel_end:	
    CLRR    _R_CNT	
    return	
 
;==================================================================== 
_TkSignalHandle_Next: 
; Stack:	Level 1
; INPUT:	 
; OUTPUT:	
; OTHER	:

;read finger data
    clrr    RTkmaskL 
    clrr    RTkmaskH

    movia   high(TAB_TOUCH_FN_DATA)
    movar   FSR1
    movia   low(TAB_TOUCH_FN_DATA)
    movar   FSR0	 

#if EnTk16	 
    jbts0   _RChannelEnL,0
    goto    READ_tk16_FN
#endif

#if EnTk17    
    jbts0   _RChannelEnL,1
    goto    READ_tk17_FN
#endif

#if EnTk18    
    jbts0   _RChannelEnL,2
    goto    READ_tk18_FN
#endif

#if EnTk19    
    jbts0   _RChannelEnL,3
    goto    READ_tk19_FN
#endif

#if EnTk20    
    jbts0   _RChannelEnL,4
    goto    READ_tk20_FN
#endif

#if EnTk21    
    jbts0   _RChannelEnL,5
    goto    READ_tk21_FN
 #endif

#if EnTk22   
    jbts0   _RChannelEnL,6
    goto    READ_tk22_FN
#endif

#if EnTk23    
    jbts0   _RChannelEnL,7
    goto    READ_tk23_FN
#endif

#if EnTk24    
    jbts0   _RChannelEnH,0
    goto    READ_tk24_FN
#endif

#if EnTk25    
    jbts0   _RChannelEnH,1
    goto    READ_tk25_FN
#endif

#if EnTk26    
    jbts0   _RChannelEnH,2
    goto    READ_tk26_FN    
#endif

#if EnTk27    
    jbts0   _RChannelEnH,3
    goto    READ_tk27_FN    
#endif

#if EnTk28    
    jbts0   _RChannelEnH,4
    goto    READ_tk28_FN    
#endif

#if EnTk29    
    jbts0   _RChannelEnH,5
    goto    READ_tk29_FN    
#endif

#if EnTk30    
    jbts0   _RChannelEnH,6
    goto    READ_tk30_FN    
#endif

#if EnTk31    
    jbts0   _RChannelEnH,7
    goto    READ_tk31_FN    
#endif

    bset    berror_F
    goto    READ_tkx_FN_end_1   ;error,no tk ch en 

#if EnTk16 
READ_tk16_FN:
    bset     RTkmaskL,0
    bclr     _RChannelEnL,0	 	
    goto     READ_tkx_FN_end_1			
#endif

#if EnTk17	
READ_tk17_FN:
    bset     RTkmaskL,1
    bclr     _RChannelEnL,1	 		
    goto     READ_tkx_FN_end_1	
#endif

#if EnTk18	 
READ_tk18_FN:
    bset     RTkmaskL,2 
    bclr     _RChannelEnL,2		 
    goto     READ_tkx_FN_end_1
#endif

#if EnTk19
READ_tk19_FN:
    bset     RTkmaskL,3 
    bclr     _RChannelEnL,3	 	
    goto     READ_tkx_FN_end_1
#endif

#if EnTk20		 
READ_tk20_FN:
    bset     RTkmaskL,4 
    bclr     _RChannelEnL,4	 		
    goto     READ_tkx_FN_end_1
#endif

#if EnTk21	 
READ_tk21_FN:
    bset     RTkmaskL,5 
    bclr     _RChannelEnL,5	 	
    goto     READ_tkx_FN_end_1
#endif

#if EnTk22	 
READ_tk22_FN:
    bset     RTkmaskL,6
    bclr     _RChannelEnL,6	 	
    goto     READ_tkx_FN_end_1
#endif

#if EnTk23	 
READ_tk23_FN:
    bset     RTkmaskL,7 
    bclr     _RChannelEnL,7	  
    goto     READ_tkx_FN_end_1
#endif

#if EnTk24	 
READ_tk24_FN:
    bset     RTkmaskH,0 
    bclr     _RChannelEnH,0		 
    goto    READ_tkx_FN_end_1
#endif

#if EnTk25	 
READ_tk25_FN:
    bset     RTkmaskH,1 
    bclr    _RChannelEnH,1	 	
    goto    READ_tkx_FN_end_1
#endif

#if EnTk26	 
READ_tk26_FN:
    bset     RTkmaskH,2 
    bclr     _RChannelEnH,2	 
    goto     READ_tkx_FN_end_1
#endif

#if EnTk27	 
READ_tk27_FN:
    bset     RTkmaskH,3 
    bclr     _RChannelEnH,3	 
    goto     READ_tkx_FN_end_1
#endif

#if EnTk28	 
READ_tk28_FN:
    bset     RTkmaskH,4 
    bclr     _RChannelEnH,4	 
    goto     READ_tkx_FN_end_1
#endif

#if EnTk29	 
READ_tk29_FN:
    bset     RTkmaskH,5 
    bclr     _RChannelEnH,5	 
    goto     READ_tkx_FN_end_1
#endif

#if EnTk30	 
READ_tk30_FN:
    bset     RTkmaskH,6 
    bclr     _RChannelEnH,6	 
    goto     READ_tkx_FN_end_1
#endif	

#if EnTk31	 
READ_tk31_FN:
    bset     RTkmaskH,7 
    bclr     _RChannelEnH,7	 
    goto     READ_tkx_FN_end_1
#endif
  
READ_tkx_FN_end_1:

    return
    
;==================================================================== 
_other_lib_fun1

#if  (TKLib_FILTER_LEVEL==0)
  return
#endif
#if  (TKLib_FILTER_LEVEL>0)

  goto  _other_fun1

#endif

;================================================================================  
_other_lib_fun2 
#if  (TKLib_FILTER_LEVEL==0)
  return
#endif
#if  (TKLib_FILTER_LEVEL>0)

  goto  _other_fun2

#endif	
;================================================================================  
  end
  
;*********************************END OF FILE************************************
                                  