/*******************(C) COPYRIGHT 2020 Masses-Chip ******************************
* File Name          : M8P634_Touch_M1_UartDebug_LIB_Init.C
* Author             : MASSES CHIP
* Version            : V2.06
* Date               : 2020/03/30
********************************************************************************



*******************************************************************************/

//================================================================================
#include "M8P634.h"
#include "M8P634_Touch_M1_UartDebug_LIB_Init.H"

//================================================================================
extern unsigned char RTkTemp1;
extern unsigned char RTkTemp2;

//================================================================================
#if TKUartDebugLib_DEBUG_MODE_SWITCH
void TK_TouchUartDebug_Init(void)
{
  __asm

  MESSG "    串口调试功能：已开启，请调试结束后关闭"

#if TKUartDebugLib_DEBUG_UART_SELECT
//tx  PIN PB6
  bset    OEB,6	     //tx pin out put
  movia   b'10000000'  // txen 异步 8bit 1:4
  movar   TX0CR

  movia   high(16000000/4/TKUartDebugLib_BAUDRATE-1)
  movar   BRGDH
  movia   low(16000000/4/TKUartDebugLib_BAUDRATE-1)  // 16M(fosc)/4/(0x03+1) = 1M Baudrate = fosc/n/(BRGDH+1)
  movar   BRGDL

  MESSG "    串口调试端口：使用的是MCU硬件资源，端口只能在PB6上 "

#else
  BSET    OE_UART_TX,N_UART_TX	     //tx pin out put

  MOVIA   b'00001000' // UP FOSC 1:1
  MOVAR   T1CR

  MOVIA   high(T1_LOAD_C_Init)
  MOVAR   TC1PRH
  MOVIA   low(T1_LOAD_C_Init)
  MOVAR   TC1PRL

  MESSG "    串口调试端口：使用的是IO软件模拟，端口可根据需求配置，软件串口使用的是定时器TC1，若与其它程序有冲突，请做调整 "


#endif
  __endasm;
}

#endif

//================================================================================
#if TKUartDebugLib_DEBUG_MODE_SWITCH
void TK_Debug_Mode_Uart_SendChar(void)
{
  __asm
#if TKUartDebugLib_DEBUG_UART_SELECT
  MOVAR   TX0REG
  jbts1   TX0CR,6
  goto    $-1
#else
  MOVAR   R_UART_TX_BUF
  CALL    _TASK_UART_DATATX
#endif
  __endasm;
}

#endif

//================================================================================
#if TKUartDebugLib_DEBUG_MODE_SWITCH
void TK_Debug_Mode_SendWord(void)
{
  __asm
#if TKUartDebugLib_DEBUG_UART_SELECT
//   MOV    TX0REG,_RTkTemp2 //high
  MOVR    _RTkTemp2,A
  MOVAR   TX0REG

  jbts1  INTF0,4 //TXIF
  goto   $-1

//    MOV    TX0REG,_RTkTemp1	//low
  MOVR    _RTkTemp1,A
  MOVAR   TX0REG

  jbts1  TX0CR,6
  goto   $-1
#else

//    MOV		R_UART_TX_BUF,_RTkTemp2  //high
  MOVR    _RTkTemp2,A
  MOVAR   R_UART_TX_BUF


  CALL	_TASK_UART_DATATX

//    MOV    	R_UART_TX_BUF,_RTkTemp1	//low
  MOVR    _RTkTemp1,A
  MOVAR   R_UART_TX_BUF

  CALL	_TASK_UART_DATATX
#endif
  __endasm;
}

#endif

#if (TKUartDebugLib_DEBUG_MODE_SWITCH&&(TKUartDebugLib_DEBUG_UART_SELECT==0))
//====================================================================
void TASK_UART_DATATX(void)
{
  __asm
  BCLR		bTC1IF
  BSET		bTC1IE
  CLRR		TC1CH
  CLRR		TC1CL
  BSET		T1CR,7
  CLRR		R_UART_TX_CNT

  UART_LOOP:
  JBTS0		bTC1IE
  GOTO		UART_LOOP

  BCLR		T1CR,7
  __endasm;
}

#endif
//================================================================================

//*********************************END OF FILE************************************
